c this is the main program for "proces" as described in
c   Section 7.3 of the UnkelScope Guide
c
c this declares the usual integers as *2 instead of *4
          implicit integer*2 (i-n)
c this declares the arrays storing the labels as character*1
       character*1 bpv1la,bph1la,bpt1la,
     $             bpv2la,bph2la,bpt2la,
     $             bpv3la,bph3la,bpt3la,
     $             bpv4la,bph4la,bpt4la,
     $             bhead1,bhead2
          parameter (n41=4096)
c this common holds the actual data for each of the traces.
      common/mdatf1/VERT1(n41),HORZ1(n41),TIME1(n41)
      common/mdatf2/VERT2(n41),HORZ2(n41),TIME2(n41)
      common/mdatf3/VERT3(n41),HORZ3(n41),TIME3(n41)
      common/mdatf4/VERT4(n41),HORZ4(n41),TIME4(n41)
c this common holds the number of channels and the number of
c      data points in each trace
          common/mdatan/nchd,npt1,npt2,npt3,npt4
c this common holds the labels for the traces
c      for example bpv1la is the label for vertical trace 1
          common/mdatal/
     $ bpv1la(20),bph1la(20),bpt1la(20),
     $ bpv2la(20),bph2la(20),bpt2la(20),
     $ bpv3la(20),bph3la(20),bpt3la(20),
     $ bpv4la(20),bph4la(20),bpt4la(20)
          common/mdatah/
     $ bhead1(40),bhead2(40)
c this common holds numbers used for input and output. DONOT change them
       common/munits/luset,ludis,lsio1,lsio2,lsio3,lsio4
c this common holds the names used to access the data files. DONOT change them
       common/mnames/bfinp(10),bfout(10)
c
c now starts the program
c
c setup initial values
        call init(1024)
c get input and output file names as needed
c       codes for nin and nout:
c         0 - dont want any
c         1 - binary file
c         2 - ascii file for transfer
c         3 - ascii file suitable for printing or porting to lotus etc.
c for this case set nin=1 to read binary file as input
        nin = 1
c for this case set nout=1 to write binary file
        nout = 1
        call innout(nin,nout)
c if there is an input file open it and read the file
c       routine binput prints out certain things about the file
c
        if(nin .gt. 0)call binput(nin,maxch,maxlen,ner)
c
c
c this is the part of the file that actually processes the data
c   determine the time step assuming that points are evenly spaced
       dtime=time1(2)-time1(1)
c   set the initial energy to zero
       energy=0.0
c  do loop to do processing for all points
       do 50 i=1,npt1
c  compute the power for point i
c   power is stored in kilowatts
       power=vert1(i)*vert2(i)/1000.
c  add the energy in the past time step
       energy=energy+power*dtime
c  now store values into the arrays horz1 and horz2
       horz1(i)=power
       horz2(i)=energy
c  the end of the loop
50     continue
c now to get the labels set properly
c             length   array    quoted string
c
       call bstuf(20,bph1la,'   Power (kwatts)   ')
       call bstuf(20,bph2la,'  Energy (kJoules)  ')
c
c if there is an output file, open it and write the file
c    nout=1 means that a binary file will be written
        if(nout .gt. 0)call boutpu(nout,maxch,maxlen,ner)
c
c program stops
        stop
        end
